<template>
  <div class="">
    <PageTitle>Scheduler</PageTitle>
    <div
      class="d-flex flex-column justify-content-center drop-shadow border-radius p-4"
    >
      <!-- Regions select -->
      <div
        class="text-center col-lg-5 mb-3 align-self-center d-flex align-items-center"
      >
        <div>REGIO:</div>
        <select
          v-model="currentRegion"
          class="form-select ms-2"
          @change="filterRounds(currentRegion)"
        >
          <option
            v-for="(region, regionIndex) in regions"
            :value="regionIndex"
            :key="'region' + regionIndex"
          >
            {{ region.name }}
          </option>
        </select>
      </div>
      <!-- Round select -->
      <div
        class="text-center col-lg-5 mb-3 align-self-center d-flex align-items-center"
        v-if="filteredRounds.length"
      >
        <div>RONDE:</div>
        <select
          v-model="selectedRound"
          @change="getBuildings(selectedRound)"
          class="form-select ms-2"
        >
          <option
            v-for="(round, roundIndex) in filteredRounds"
            :value="roundIndex"
            :key="'round' + roundIndex"
          >
            {{ round.name }}
          </option>
        </select>
      </div>
      <!-- 
      <div v-else class="text-center">Deze regio heeft nog geen route</div> -->

      <!-- Building select -->

      <div
        v-if="buildings.length && filteredRounds.length"
        class="text-center col-lg-5 mb-3 align-self-center d-flex align-items-center"
      >
        <div>GEBOUW:</div>
        <select
          v-model="selectedBuildingId"
          class="form-select ms-2"
          @change="changeCurrentBuilding()"
        >
          <option disabled value="">Select an option</option>
          <option
            v-for="(build, buildingIndex) in buildings"
            :value="buildingIndex"
            :key="'building' + buildingIndex"
          >
            {{ build.name }}
          </option>
        </select>
      </div>
      <div v-if="rounds.length == null" class="text-center">
        Deze regio heeft nog geen routes
      </div>
      <div v-else-if="!buildings" class="text-center">
        Deze route heeft nog geen gebouwen
      </div>
    </div>
    <div v-if="currentBuilding != null && filteredRounds.length">
      <div class="drop-shadow border-radius p-4">
        <SheduleCreator
          v-if="typeof currentBuilding.scheduleString == 'string'"
          :buildingName="currentBuilding.name"
          :buildingObject="currentBuilding"
          :buildingShedule="JSON.parse(currentBuilding.scheduleString)"
          v-model:updatedShedule="currentBuilding.scheduleString"
        />
        <SheduleCreator
          v-else-if="currentBuilding !== null"
          :buildingName="currentBuilding.name"
          :buildingObject="currentBuilding"
          :buildingShedule="empty"
          v-model:updatedShedule="currentBuilding.scheduleString"
        />
      </div>
    </div>
  </div>
</template>

<script>
import PageTitle from "./atoms/PageTitle.vue";
import SheduleCreator from "./organisms/SheduleCreator.vue";
import axios from "axios";
import store from "@/store/auth";

export default {
  components: { PageTitle, SheduleCreator },
  data() {
    return {
      initial: {
        even: {
          0: [],
          1: [{ type: "PMD" }, { type: "PMD" }],
          2: [{ type: "PMD" }],
          3: [],
          4: [],
        },
        odd: {
          0: [],
          1: [{ type: "PMD" }],
          2: [],
          3: [{ type: "PMD" }],
          4: [],
        },
      },
      empty: {
        even: {
          0: [],
          1: [],
          2: [],
          3: [],
          4: [],
        },
        odd: {
          0: [],
          1: [],
          2: [],
          3: [],
          4: [],
        },
      },
      buildings: [],
      selectedRound: null,
      selectedBuildingId: null,
      rounds: [],
      currentBuilding: {},
      currentRegion: null,
      regions: [],
      filteredRounds: [],
    };
  },
  created() {
    this.getRounds();
    this.getRegions();
  },
  methods: {
    getBuildings(roundId) {
      this.buildings = [];
      this.selectedBuildingId = null;
      if (this.rounds.length) {
        let buildingIds = this.rounds[roundId].buildingIds;
        buildingIds.forEach((id) => {
          axios.get("/api/building/" + id).then((response) => {
            if (response.status === 200) {
              this.buildings.push(response.data);
              this.selectedBuildingId = 0;
              console.log("this.buildings");
              console.log(this.buildings);
              this.currentBuilding = this.buildings[0];
              console.log("this.currentBuilding");
              console.log(this.currentBuilding);
            }
            store.commit("general/setLoading", false);
          });
        });
      }
      /*   */
    },
    getRounds() {
      axios.get("/api/round").then((response) => {
        if (response.status === 200) {
          this.getBuildings(response.data[0].buildingIds);
          this.rounds = response.data;
        }
        store.commit("general/setLoading", false);
      });
    },
    getRegions() {
      axios.get("/api/region").then((response) => {
        if (response.status === 200) {
          console.log(response.data);
          this.regions = response.data;
        }
        store.commit("general/setLoading", false);
      });
    },
    fetchBuildings() {
      this.getBuildings(this.selectedRound);
    },
    changeCurrentBuilding() {
      this.currentBuilding = this.buildings[this.selectedBuildingId];
      if (this.currentBuilding.scheduleString == null) {
        this.currentBuilding.scheduleString = JSON.stringify(this.empty);
      }
    },
    filterRounds(region) {
      this.filteredRounds = this.rounds.filter(
        (round) => round.region.id === this.regions[region].id
      );
    },
  },
  computed: {},
};
</script>

<style lang="scss" scoped>
@import "../assets/css/base.css";
@import "../assets/css/colors.css";
</style>
